unit hiImg_CurveBezier;

interface

uses Windows,Kol,Share,Img_Draw;

{$I share.inc}

type
  ThiImg_CurveBezier= class(THIDraw2PA)
   private
   public
     _prop_Offset: integer;
     _data_Offset: THI_Event;

     procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure ThiImg_CurveBezier._work_doDraw;
var    dt: TData;
       pen: HPEN;
       PointsArray: array[0..3] of Tpoint;
begin
       dt := _Data;
TRY
   if not ImgGetDC(_Data) then exit;
   ReadXY(_Data);

   ImgNewSizeDC;
   
   PointsArray[0] := MakePoint(x1, y1); //start position
   PointsArray[3] := MakePoint(x2, y2); //finish position 
   PointsArray[1] := MakePoint(x3, y3); //first curve
   PointsArray[2] := MakePoint(x4, y4); //second curve  

   pen := CreatePen(ReadInteger(_Data,_data_StylePen,_prop_StylePen), Round((fScale.x + fScale.y) * ReadInteger(_Data,_data_Size,_prop_Size)/2), Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color)));
   
   SelectObject(pDC,Pen);
   PolyBezier(pDC, PointsArray, 4); //draw line
   DeleteObject(Pen);

FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onDraw,dt);
END;
end;

end.