unit hiImg_FloodFill;

interface

uses windows,Kol,Share,Debug,Img_Draw;

type
  THIImg_FloodFill = class(THIDraw2P)
   private
   public
    _prop_FillType:integer;
    _prop_ColorBorder:integer;
    _data_ColorBorder:THI_Event;
    _data_FillType:THI_Event;
    procedure _work_doDraw(var _Data:TData; Index:word);
  end;

implementation

procedure THIImg_FloodFill._work_doDraw;
var   dt: TData;
      color, colorborder: TColor;
      br: HBRUSH;
      brush: integer;
      pattern: PBitmap;
begin
   dt := _Data;
TRY
   if not ImgGetDC(_Data) then exit;
   
   color := Color2RGB(ReadInteger(_Data,_data_Color,_prop_Color)); 
   colorborder := Color2RGB(ReadInteger(_Data,_data_ColorBorder,_prop_ColorBorder));
   brush := ReadInteger(_Data,_data_Style,_prop_Style);
   
   ReadXY(_Data);
   
   ImgNewSizeDC;
   
   case brush of
    0: br := CreateSolidBrush(color);
    1: begin
        pattern := ReadBitmap(_Data,_data_Pattern,nil);
        if (pattern = nil) or pattern.Empty then br := CreateSolidBrush(color)
        else br := CreatePatternBrush(pattern.Handle);
       end;
    else br  := CreateHatchBrush(Brush - 2, color);
   end;
   
   SelectObject(pDC, br);
   case ReadInteger(_Data,_data_FillType,_prop_FillType) of
    0: ExtFloodFill(pDC, x1, y1, GetPixel(pDC, x1, y1), FLOODFILLSURFACE);
    1: ExtFloodFill(pDC, x1, y1, colorborder, FLOODFILLBORDER);
   end; 
   DeleteObject(br);
FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onDraw,dt);
END;
end;

end.
